"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addProperties = exports.addProperty = void 0;
/**
 * A more type-friendly version of <kbd>Object.defineProperty</kbd>.
 * See {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperty | Object.defineProperty on MDN}.
 */
const addProperty = (target, key, descriptor) => {
    return Object.defineProperty(target, key, descriptor);
};
exports.addProperty = addProperty;
/**
 * A more type-friendly version of <kbd>Object.defineProperties</kbd>.
 * See {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperties | Object.defineProperties on MDN}.
 */
const addProperties = (target, descriptors) => {
    return Object.defineProperties(target, descriptors);
};
exports.addProperties = addProperties;
//# sourceMappingURL=add-property.js.map