"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.intRange = void 0;
const guard_1 = require("@rickosborne/guard");
const add_property_js_1 = require("./add-property.js");
exports.intRange = {
    from(startInclusive) {
        let skipBy = 1;
        let stop;
        let inclusive = false;
        const generatorFn = function* () {
            let more;
            if (skipBy < 0) {
                more = inclusive ? ((n) => n >= stop) : ((n) => n > stop);
            }
            else {
                more = inclusive ? ((n) => n <= stop) : ((n) => n < stop);
            }
            for (let i = startInclusive; more(i); i += skipBy) {
                yield i;
            }
        };
        const addToArray = (gen) => {
            if ((0, guard_1.hasOwn)(gen, "toArray", (f) => typeof f === "function")) {
                return gen;
            }
            return (0, add_property_js_1.addProperty)(gen, "toArray", {
                configurable: false,
                enumerable: false,
                value: () => Array.from(generatorFn()),
                writable: false,
            });
        };
        const toExclusive = (stopExclusive) => {
            stop = stopExclusive;
            inclusive = false;
            return addToArray(generatorFn());
        };
        const toInclusive = (stopInclusive) => {
            stop = stopInclusive;
            inclusive = true;
            return addToArray(generatorFn());
        };
        const by = (skip) => {
            skipBy = skip;
            return { toExclusive, toInclusive };
        };
        return {
            by,
            get down() {
                skipBy = -1;
                return { toExclusive, toInclusive };
            },
            get up() {
                skipBy = 1;
                return { toExclusive, toInclusive };
            },
        };
    },
};
//# sourceMappingURL=int-range.js.map