/**
 * A more type-friendly version of <kbd>Object.defineProperty</kbd>.
 * See {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperty | Object.defineProperty on MDN}.
 */
export const addProperty = (target, key, descriptor) => {
    return Object.defineProperty(target, key, descriptor);
};
/**
 * A more type-friendly version of <kbd>Object.defineProperties</kbd>.
 * See {@link https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperties | Object.defineProperties on MDN}.
 */
export const addProperties = (target, descriptors) => {
    return Object.defineProperties(target, descriptors);
};
//# sourceMappingURL=add-property.js.map