import { Comparator } from "@rickosborne/typical";
export type ChainableComparator<T> = Comparator<T> & {
    get desc(): ChainableComparator<T>;
    get nullsFirst(): ChainableComparator<T | undefined | null>;
    get nullsLast(): ChainableComparator<T | undefined | null>;
};
export declare const withNullsFirst: <T>(comparator: Comparator<T>) => Comparator<T | null | undefined>;
export declare const withNullsLast: <T>(comparator: Comparator<T>) => Comparator<T | null | undefined>;
export declare const chainableComparator: <T>(comparator: Comparator<T>) => ChainableComparator<T>;
export declare const numberAsc: Comparator<number>;
export type ComparatorBuilder<T> = {
    build(): Comparator<T>;
    get desc(): ComparatorBuilder<T>;
    get nullsFirst(): ComparatorBuilder<T>;
    get nullsLast(): ComparatorBuilder<T>;
    num(accessor: (t: T) => (undefined | number)): ComparatorBuilder<T>;
    str(accessor: (t: T) => (undefined | string)): ComparatorBuilder<T>;
};
export declare const comparatorBuilder: <T>() => ComparatorBuilder<T>;
//# sourceMappingURL=comparator.d.ts.map