import type { Queue } from "./queue.js";
import type { Comparator } from "@rickosborne/typical";
/**
 * @internal
 */
type SkipNode<T> = {
    forward: (SkipNode<T> | undefined)[];
    value: T;
};
export declare class SkipList<T> implements Queue<T> {
    protected readonly comparator: Comparator<T>;
    protected readonly maxLevel: number;
    protected readonly random: () => number;
    private readonly root;
    private level;
    private count;
    constructor(comparator: Comparator<T>, maxLevel?: number, random?: () => number);
    private buildUpdate;
    add(value: T): void;
    remove(value: T): void;
    get length(): number;
    peek(): T | undefined;
    take(): T | undefined;
    toArray(): T[];
    values(): Generator<T, void, undefined>;
    valuesAndIndexes(): Generator<[T, number], void, undefined>;
    protected buildNode(value: T, level: number): SkipNode<T>;
    protected randomLevel(): number;
}
export declare const skipList: <T>(comparator: Comparator<T>) => SkipList<T>;
export {};
//# sourceMappingURL=skip-list.d.ts.map